package f2;

/**
 * This shows automatic type conversion when using the + operator (+ operator is
 * "overloaded" it can handle many different types)
 *
 * @author hajo
 *
 */
public class AutomaticTypeConversions {

    public static void main(String[] args) {
        System.out.println(1 + 1);
        System.out.println("1" + "1");
        System.out.println(1.0 + 1.0);

        System.out.println(1 + "1");
        System.out.println(1.0 + "1");
        System.out.println("1" + Math.PI);
        System.out.println('1' + 1);
        System.out.println(1 + new Integer(1));
        System.out.println(new Integer(1) + new Double(1.0));
        System.out.println(1 + 2 + " mammals");
        System.out.println("mammals " + 1 + 2);
    }
}



/*  Solution
         + operator works for many types (overloaded)
        System.out.println(1 + 1);  // + as integer arithmetic 
        System.out.println("1" + "1");// + as string concatenation
        System.out.println(1.0 + 1.0);  // + as floating point arithmetic 

        System.out.println(1 + "1");  // String conversion, then concatenation
        System.out.println(1.0 + "1");  // String conversion, then concatenation
        System.out.println("1" + Math.PI);  // String conversion, then concatenation
        System.out.println('1' + 1); // Char to integer, then integer arithmetic
        System.out.println(1 + new Integer(1)); //Unboxing, then integer arithmetic
        System.out.println(new Integer(1) + new Double(1.0));  // Unboxing, then to double, floating point arithmetic performed
        System.out.println(1 + 2 + " mammals"); // Integer arithmetic, string conversion, then concatenation
        System.out.println("mammals " + 1 + 2); // String conversion, then concatenation

 */